Index: trunk/source/processes/electromagnetic/lowenergy/src/G4FinalStateElasticScreenedRutherford.cc
===================================================================
--- trunk/source/processes/electromagnetic/lowenergy/src/G4FinalStateElasticScreenedRutherford.cc	(revision 1013)
+++ trunk/source/processes/electromagnetic/lowenergy/src/G4FinalStateElasticScreenedRutherford.cc	(revision 1055)
@@ -24,6 +24,6 @@
 // ********************************************************************
 //
-// $Id: G4FinalStateElasticScreenedRutherford.cc,v 1.4 2008/07/14 20:47:34 sincerti Exp $
-// GEANT4 tag $Name: geant4-09-02 $
+// $Id: G4FinalStateElasticScreenedRutherford.cc,v 1.5 2009/05/02 15:07:47 sincerti Exp $
+// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
 
 #include "G4FinalStateElasticScreenedRutherford.hh"
@@ -35,4 +35,14 @@
   lowEnergyLimit = 200 * eV;
   highEnergyLimit = 10 * MeV;
+
+   G4cout << G4endl;
+   G4cout << "*******************************************************************************" << G4endl;
+   G4cout << "*******************************************************************************" << G4endl;
+   G4cout << "   The class G4FinalStateElasticScreenedRutherford is NOT SUPPORTED ANYMORE. " << G4endl;
+   G4cout << "   It will be REMOVED with the next major release of Geant4. " << G4endl;
+   G4cout << "   Please consult: https://twiki.cern.ch/twiki/bin/view/Geant4/LoweProcesses" << G4endl;
+   G4cout << "*******************************************************************************" << G4endl;
+   G4cout << "*******************************************************************************" << G4endl;
+   G4cout << G4endl;
 }
 
Index: trunk/source/processes/electromagnetic/lowenergy/src/G4FinalStateExcitationBorn.cc
===================================================================
--- trunk/source/processes/electromagnetic/lowenergy/src/G4FinalStateExcitationBorn.cc	(revision 1013)
+++ trunk/source/processes/electromagnetic/lowenergy/src/G4FinalStateExcitationBorn.cc	(revision 1055)
@@ -24,6 +24,6 @@
 // ********************************************************************
 //
-// $Id: G4FinalStateExcitationBorn.cc,v 1.3 2008/07/14 20:47:34 sincerti Exp $
-// GEANT4 tag $Name: geant4-09-02 $
+// $Id: G4FinalStateExcitationBorn.cc,v 1.4 2009/05/02 15:07:47 sincerti Exp $
+// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
 
 #include "G4FinalStateExcitationBorn.hh"
@@ -35,4 +35,14 @@
   lowEnergyLimit = 500 * keV;
   highEnergyLimit = 10 * MeV;
+
+   G4cout << G4endl;
+   G4cout << "*******************************************************************************" << G4endl;
+   G4cout << "*******************************************************************************" << G4endl;
+   G4cout << "   The class G4FinalStateExcitationBorn is NOT SUPPORTED ANYMORE. " << G4endl;
+   G4cout << "   It will be REMOVED with the next major release of Geant4. " << G4endl;
+   G4cout << "   Please consult: https://twiki.cern.ch/twiki/bin/view/Geant4/LoweProcesses" << G4endl;
+   G4cout << "*******************************************************************************" << G4endl;
+   G4cout << "*******************************************************************************" << G4endl;
+   G4cout << G4endl;
 }
 
Index: trunk/source/processes/electromagnetic/lowenergy/src/G4FinalStateExcitationEmfietzoglou.cc
===================================================================
--- trunk/source/processes/electromagnetic/lowenergy/src/G4FinalStateExcitationEmfietzoglou.cc	(revision 1013)
+++ trunk/source/processes/electromagnetic/lowenergy/src/G4FinalStateExcitationEmfietzoglou.cc	(revision 1055)
@@ -24,6 +24,6 @@
 // ********************************************************************
 //
-// $Id: G4FinalStateExcitationEmfietzoglou.cc,v 1.5 2008/12/05 11:58:16 sincerti Exp $
-// GEANT4 tag $Name: geant4-09-02 $
+// $Id: G4FinalStateExcitationEmfietzoglou.cc,v 1.6 2009/05/02 15:07:47 sincerti Exp $
+// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
 
 #include "G4FinalStateExcitationEmfietzoglou.hh"
@@ -35,4 +35,14 @@
   lowEnergyLimit = 8.23 * eV;
   highEnergyLimit = 10 * MeV;
+
+   G4cout << G4endl;
+   G4cout << "*******************************************************************************" << G4endl;
+   G4cout << "*******************************************************************************" << G4endl;
+   G4cout << "   The class G4FinalStateExcitationEmfietzoglou is NOT SUPPORTED ANYMORE. " << G4endl;
+   G4cout << "   It will be REMOVED with the next major release of Geant4. " << G4endl;
+   G4cout << "   Please consult: https://twiki.cern.ch/twiki/bin/view/Geant4/LoweProcesses" << G4endl;
+   G4cout << "*******************************************************************************" << G4endl;
+   G4cout << "*******************************************************************************" << G4endl;
+   G4cout << G4endl;
 }
 
Index: trunk/source/processes/electromagnetic/lowenergy/src/G4FinalStateExcitationMillerGreen.cc
===================================================================
--- trunk/source/processes/electromagnetic/lowenergy/src/G4FinalStateExcitationMillerGreen.cc	(revision 1013)
+++ trunk/source/processes/electromagnetic/lowenergy/src/G4FinalStateExcitationMillerGreen.cc	(revision 1055)
@@ -24,6 +24,6 @@
 // ********************************************************************
 //
-// $Id: G4FinalStateExcitationMillerGreen.cc,v 1.3 2008/07/14 20:47:34 sincerti Exp $
-// GEANT4 tag $Name: geant4-09-02 $
+// $Id: G4FinalStateExcitationMillerGreen.cc,v 1.4 2009/05/02 15:07:47 sincerti Exp $
+// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
 
 #include "G4FinalStateExcitationMillerGreen.hh"
@@ -35,4 +35,14 @@
   lowEnergyLimit = 10 * eV;
   highEnergyLimit = 10 * MeV;
+
+   G4cout << G4endl;
+   G4cout << "*******************************************************************************" << G4endl;
+   G4cout << "*******************************************************************************" << G4endl;
+   G4cout << "   The class G4FinalStateExcitationMillerGreen is NOT SUPPORTED ANYMORE. " << G4endl;
+   G4cout << "   It will be REMOVED with the next major release of Geant4. " << G4endl;
+   G4cout << "   Please consult: https://twiki.cern.ch/twiki/bin/view/Geant4/LoweProcesses" << G4endl;
+   G4cout << "*******************************************************************************" << G4endl;
+   G4cout << "*******************************************************************************" << G4endl;
+   G4cout << G4endl;
 }
 
Index: trunk/source/processes/electromagnetic/lowenergy/src/G4FinalStateIonisationBorn.cc
===================================================================
--- trunk/source/processes/electromagnetic/lowenergy/src/G4FinalStateIonisationBorn.cc	(revision 1013)
+++ trunk/source/processes/electromagnetic/lowenergy/src/G4FinalStateIonisationBorn.cc	(revision 1055)
@@ -24,6 +24,6 @@
 // ********************************************************************
 //
-// $Id: G4FinalStateIonisationBorn.cc,v 1.16 2008/12/06 13:47:12 sincerti Exp $
-// GEANT4 tag $Name: geant4-09-02 $
+// $Id: G4FinalStateIonisationBorn.cc,v 1.17 2009/05/02 15:07:47 sincerti Exp $
+// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
 
 #include "G4FinalStateIonisationBorn.hh"
@@ -124,4 +124,14 @@
     G4Exception("G4FinalStateIonisationBorn Constructor: proton is not defined");
   }
+
+   G4cout << G4endl;
+   G4cout << "*******************************************************************************" << G4endl;
+   G4cout << "*******************************************************************************" << G4endl;
+   G4cout << "   The class G4FinalStateIonisationBorn is NOT SUPPORTED ANYMORE. " << G4endl;
+   G4cout << "   It will be REMOVED with the next major release of Geant4. " << G4endl;
+   G4cout << "   Please consult: https://twiki.cern.ch/twiki/bin/view/Geant4/LoweProcesses" << G4endl;
+   G4cout << "*******************************************************************************" << G4endl;
+   G4cout << "*******************************************************************************" << G4endl;
+   G4cout << G4endl;
 }
 
Index: trunk/source/processes/electromagnetic/lowenergy/src/G4FinalStateIonisationRudd.cc
===================================================================
--- trunk/source/processes/electromagnetic/lowenergy/src/G4FinalStateIonisationRudd.cc	(revision 1013)
+++ trunk/source/processes/electromagnetic/lowenergy/src/G4FinalStateIonisationRudd.cc	(revision 1055)
@@ -24,6 +24,6 @@
 // ********************************************************************
 //
-// $Id: G4FinalStateIonisationRudd.cc,v 1.8 2008/08/20 14:51:48 sincerti Exp $
-// GEANT4 tag $Name: geant4-09-02 $
+// $Id: G4FinalStateIonisationRudd.cc,v 1.9 2009/05/02 15:07:47 sincerti Exp $
+// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
 
 #include "G4FinalStateIonisationRudd.hh"
@@ -70,4 +70,14 @@
   lowEnergyLimit[helium] = 1. * keV;
   highEnergyLimit[helium] = 10. * MeV;
+
+   G4cout << G4endl;
+   G4cout << "*******************************************************************************" << G4endl;
+   G4cout << "*******************************************************************************" << G4endl;
+   G4cout << "   The class G4FinalStateIonisationRudd is NOT SUPPORTED ANYMORE. " << G4endl;
+   G4cout << "   It will be REMOVED with the next major release of Geant4. " << G4endl;
+   G4cout << "   Please consult: https://twiki.cern.ch/twiki/bin/view/Geant4/LoweProcesses" << G4endl;
+   G4cout << "*******************************************************************************" << G4endl;
+   G4cout << "*******************************************************************************" << G4endl;
+   G4cout << G4endl;
 }
 
Index: trunk/source/processes/electromagnetic/lowenergy/src/G4FinalStateProduct.cc
===================================================================
--- trunk/source/processes/electromagnetic/lowenergy/src/G4FinalStateProduct.cc	(revision 1013)
+++ trunk/source/processes/electromagnetic/lowenergy/src/G4FinalStateProduct.cc	(revision 1055)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: G4FinalStateProduct.cc,v 1.5 2007/11/09 20:11:04 pia Exp $
-// GEANT4 tag $Name: geant4-09-02 $
+// $Id: G4FinalStateProduct.cc,v 1.6 2009/01/20 07:50:28 sincerti Exp $
+// GEANT4 tag $Name: geant4-09-03-beta-cand-01 $
 // 
 // Contact Author: Maria Grazia Pia (Maria.Grazia.Pia@cern.ch)
@@ -53,5 +53,5 @@
 #include "G4ThreeVector.hh"
 
-G4FinalStateProduct::G4FinalStateProduct() : killStatus(false), isModified(false), localEnergyDeposit(0.), modifiedEnergy(0)
+G4FinalStateProduct::G4FinalStateProduct() : killStatus(false), doNotDepositStatus(false), isModified(false), localEnergyDeposit(0.), modifiedEnergy(0)
 {
   // empty
@@ -68,4 +68,5 @@
   // Reset object status
   killStatus = false;
+  doNotDepositStatus = false;
   isModified = false;
   localEnergyDeposit = 0.;
@@ -98,6 +99,12 @@
 }
   
+void G4FinalStateProduct::DoNotDepositEnergy()
+{
+  doNotDepositStatus = true;
+}
+
 void G4FinalStateProduct::KillPrimaryParticle()
 {
+  
   // ---- MGP ---- To be added: Handle local energy deposit here
   killStatus = true;
Index: trunk/source/processes/electromagnetic/lowenergy/src/G4IonParametrisedLossModel.cc
===================================================================
--- trunk/source/processes/electromagnetic/lowenergy/src/G4IonParametrisedLossModel.cc	(revision 1013)
+++ trunk/source/processes/electromagnetic/lowenergy/src/G4IonParametrisedLossModel.cc	(revision 1055)
@@ -37,6 +37,11 @@
 // First implementation: 10. 11. 2008
 //
-// Modifications:
-//
+// Modifications: 03. 02. 2009 - Bug fix iterators (AL)
+//                11. 03. 2009 - Introduced new table handler (G4IonDEDXHandler)
+//                               and modified method to add/remove tables
+//                               (tables are now built in initialisation phase),
+//                               Minor bug fix in ComputeDEDXPerVolume (AL)
+//                11. 05. 2009 - Introduced scaling algorithm for heavier ions:
+//                               G4IonDEDXScalingICRU73 (AL)
 //
 // Class description:
@@ -55,6 +60,11 @@
 #include "G4MaterialStoppingICRU73.hh"
 #include "G4SimpleMaterialStoppingICRU73.hh"
+#include "G4IronStoppingICRU73.hh"
+#include "G4VIonDEDXTable.hh"
+#include "G4VIonDEDXScalingAlgorithm.hh"
+#include "G4IonDEDXScalingICRU73.hh"
 #include "G4BraggIonModel.hh"
 #include "G4BetheBlochModel.hh"
+#include "G4ProductionCutsTable.hh"
 #include "G4ParticleChangeForLoss.hh"
 #include "G4LossTableManager.hh"
@@ -63,4 +73,8 @@
 #include "Randomize.hh"
 
+//#define PRINT_TABLE_BUILT
+
+
+// #########################################################################
 
 G4IonParametrisedLossModel::G4IonParametrisedLossModel(
@@ -89,7 +103,44 @@
   betheBlochModel = new G4BetheBlochModel();
 
-  // By default ICRU 73 stopping power tables are loaded
-  AddDEDXTable<G4SimpleMaterialStoppingICRU73>();
-  AddDEDXTable<G4MaterialStoppingICRU73>();
+  // By default ICRU 73 stopping power tables are loaded:
+
+  // Ions with Z above between 19 and 21: Ar-40 data is used as basis 
+  // for stopping power scaling
+  G4int ionZMin = 19;
+  G4int ionZMax = 21;
+  G4int refIonZ = 18;
+  G4int refIonA = 40;
+
+  AddDEDXTable("ICRU73-elemmat",
+           new G4SimpleMaterialStoppingICRU73,
+	   new G4IonDEDXScalingICRU73(ionZMin, ionZMax, refIonZ, refIonA));
+
+  // Ions with Z above 21: Fe-56 data is used as basis for stopping power 
+  // scaling
+  ionZMin = 22;
+  ionZMax = 102;
+  refIonZ = 26;
+  refIonA = 56;
+
+  AddDEDXTable("ICRU73-ironions",
+               new G4IronStoppingICRU73,
+	       new G4IonDEDXScalingICRU73(ionZMin, ionZMax, refIonZ, refIonA));
+
+  // Compound materials: Ar-40 data is used as basis for stopping power 
+  // scaling (except for iron ions)
+  ionZMin = 19;
+  ionZMax = 102;
+  refIonZ = 18;
+  refIonA = 40;
+
+  G4IonDEDXScalingICRU73* scaling =
+            new G4IonDEDXScalingICRU73(ionZMin, ionZMax, refIonZ, refIonA);
+
+  G4int ironIonAtomicNumber = 26;
+  scaling -> AddException(ironIonAtomicNumber);
+
+  AddDEDXTable("ICRU73-compmat",
+               new G4MaterialStoppingICRU73,
+	       scaling);
 
   // The boundaries for the range tables are set
@@ -107,5 +158,5 @@
   dedxCacheMaterial = 0;
   dedxCacheEnergyCut = 0;
-  dedxCacheIter = lossTableList.begin();
+  dedxCacheIter = lossTableList.end();
   dedxCacheTransitionEnergy = 0.0;  
   dedxCacheTransitionFactor = 0.0;
@@ -113,4 +164,5 @@
 }
 
+// #########################################################################
 
 G4IonParametrisedLossModel::~G4IonParametrisedLossModel() {
@@ -142,4 +194,5 @@
 }
 
+// #########################################################################
 
 G4double G4IonParametrisedLossModel::MinEnergyCut(
@@ -151,4 +204,5 @@
 }
 
+// #########################################################################
 
 void G4IonParametrisedLossModel::Initialise(
@@ -166,5 +220,5 @@
   dedxCacheMaterial = 0;
   dedxCacheEnergyCut = 0;
-  dedxCacheIter = lossTableList.begin();
+  dedxCacheIter = lossTableList.end();
   dedxCacheTransitionEnergy = 0.0;  
   dedxCacheTransitionFactor = 0.0;
@@ -196,4 +250,52 @@
   cutEnergies.clear();
   for(size_t i = 0; i < size; i++) cutEnergies.push_back(cuts[i]);
+
+  // All dE/dx vectors are built
+  const G4ProductionCutsTable* coupleTable=
+                     G4ProductionCutsTable::GetProductionCutsTable();
+  size_t nmbCouples = coupleTable -> GetTableSize();
+
+#ifdef PRINT_TABLE_BUILT
+    G4cout << "G4IonParametrisedLossModel::Initialise():"
+           << " Building dE/dx vectors:"
+           << G4endl;         
+#endif
+
+  for (size_t i = 0; i < nmbCouples; i++) {
+
+    const G4MaterialCutsCouple* couple = 
+                                     coupleTable -> GetMaterialCutsCouple(i);
+
+    const G4Material* material = couple -> GetMaterial();
+    //    G4ProductionCuts* productionCuts = couple -> GetProductionCuts();
+
+    for(G4int atomicNumberIon = 3; atomicNumberIon < 102; atomicNumberIon++) {
+
+       LossTableList::iterator iter = lossTableList.begin();
+       LossTableList::iterator iter_end = lossTableList.end();
+
+       for(;iter != iter_end; iter++) { 
+
+          if(*iter == 0) {
+              G4cout << "G4IonParametrisedLossModel::Initialise():"
+                     << " Skipping illegal table."
+                     << G4endl;         
+          }
+
+          G4bool isApplicable = 
+                    (*iter) -> BuildDEDXTable(atomicNumberIon, material);
+          if(isApplicable) {
+
+#ifdef PRINT_TABLE_BUILT
+             G4cout << "  Atomic Number Ion = " << atomicNumberIon
+                    << ", Material = " << material -> GetName()
+                    << ", Table = " << (*iter) -> GetName()
+                    << G4endl;      
+#endif
+             break; 
+	  }
+       }
+    }
+  }
 
   // The particle change object is cast to G4ParticleChangeForLoss
@@ -221,4 +323,5 @@
 }
 
+// #########################################################################
 
 G4double G4IonParametrisedLossModel::ComputeCrossSectionPerAtom(
@@ -285,4 +388,5 @@
 }
 
+// #########################################################################
 
 G4double G4IonParametrisedLossModel::CrossSectionPerVolume(
@@ -303,4 +407,5 @@
 }
 
+// #########################################################################
 
 G4double G4IonParametrisedLossModel::ComputeDEDXPerVolume(
@@ -342,5 +447,5 @@
   LossTableList::iterator iter = dedxCacheIter;
 
-  if(iter != lossTableList.begin()) {
+  if(iter != lossTableList.end()) {
 
      G4double transitionEnergy = dedxCacheTransitionEnergy;
@@ -369,17 +474,18 @@
         if(scaledTransitionEnergy >= lowEnergyLimit) {
 
-           G4double factor = 1.0 + dedxCacheTransitionFactor / 
-                                                           kineticEnergy;
-
            dEdx = betheBlochModel -> ComputeDEDXPerVolume(
                                       material, genericIon,
      				      scaledKineticEnergy, cutEnergy);
+        
+           dEdx *= chargeSquare;
+
+           dEdx += corrections -> ComputeIonCorrections(particle, 
+                                                 material, kineticEnergy);
+
+           G4double factor = 1.0 + dedxCacheTransitionFactor / 
+                                                           kineticEnergy;
+
 	   dEdx *= factor;
-
-        }
-        dEdx *= chargeSquare;
-
-        dEdx += corrections -> ComputeIonCorrections(particle, 
-                                                 material, kineticEnergy);
+	}
      }
   }
@@ -446,36 +552,8 @@
   if (dEdx < 0.0) dEdx = 0.0;
 
-#ifdef PRINT_DEBUG
-
-  G4cout << "########################################################"
-         << G4endl
-         << "# G4IonParametrisedLossModel::ComputeDEDXPerVolume"
-         << G4endl
-         << "# Material =" << material -> GetName() 
-         << G4endl
-         << "# Particle = " << particle -> GetParticleName()            
-         << G4endl;
-         << "# Cut energy (MeV) = " << cutEnergy/MeV  
-         << G4endl;
-  
-  G4cout << "#"
-         << std::setw(13) << std::right << "E(MeV)"
-         << std::setw(14) << "dE/dx(keV/um)"
-         << std::setw(14) << "d:dE/dx(keV/um)"
-         << std::setw(14) << "(d:dE/dx)/dE/dx"
-         << G4endl
-         << "# ------------------------------------------------------"
-         << G4endl;
-
-  G4cout << std::setw(14) << std::right << kineticEnergy / MeV
-         << std::setw(14) << (dEdx + dEdXDeltaRays) / keV * um
-         << std::setw(14) << dEdXDeltaRays / keV * um
-         << std::setw(14) << dEdXDeltaRays / (dEdx + dEdXDeltaRays) * 100.0
-         << G4endl;
-#endif
-
   return dEdx;
 }
 
+// #########################################################################
 
 void G4IonParametrisedLossModel::PrintDEDXTable(
@@ -508,5 +586,5 @@
          << std::setw(13) << std::right << "(MeV)"
          << std::setw(14) << "(MeV)"
-         << std::setw(14) << "(MeV/mm)"
+         << std::setw(14) << "(MeV/cm)"
          << std::setw(14) << "(MeV*cm2/mg)"
          << G4endl
@@ -535,5 +613,5 @@
       G4cout << std::setw(14) << std::right << energy / MeV
              << std::setw(14) << energy / atomicMassNumber / MeV
-             << std::setw(14) << dedx / MeV * mm
+             << std::setw(14) << dedx / MeV * cm
              << std::setw(14) << dedx / materialDensity / (MeV*cm2/(0.001*g)) 
              << G4endl;
@@ -541,4 +619,29 @@
 }
 
+// #########################################################################
+
+void G4IonParametrisedLossModel::PrintDEDXTableHandlers(
+                   const G4ParticleDefinition* particle,  // Projectile (ion) 
+                   const G4Material* material,  // Absorber material
+                   G4double lowerBoundary,      // Minimum energy per nucleon
+                   G4double upperBoundary,      // Maximum energy per nucleon
+                   G4int nmbBins,               // Number of bins
+                   G4bool logScaleEnergy) {     // Logarithmic scaling of energy
+
+  LossTableList::iterator iter = lossTableList.begin();
+  LossTableList::iterator iter_end = lossTableList.end();
+
+  for(;iter != iter_end; iter++) { 
+      G4bool isApplicable =  (*iter) -> IsApplicable(particle, material);
+      if(isApplicable) {  
+	(*iter) -> PrintDEDXTable(particle, material,
+                                  lowerBoundary, upperBoundary, 
+                                  nmbBins,logScaleEnergy); 
+        break;
+      } 
+  }
+}
+
+// #########################################################################
 
 void G4IonParametrisedLossModel::SampleSecondaries(
@@ -641,4 +744,5 @@
 }
 
+// #########################################################################
 
 void G4IonParametrisedLossModel::UpdateDEDXCache(
@@ -672,5 +776,5 @@
 
      // If any table is applicable, the transition factor is computed:
-     if(iter != lossTableList.begin()) {
+     if(iter != lossTableList.end()) {
 
         // Retrieving the transition energy from the parameterisation table
@@ -740,4 +844,5 @@
 }
 
+// #########################################################################
 
 void G4IonParametrisedLossModel::CorrectionsAlongStep(
@@ -767,4 +872,6 @@
   G4double kineticEnergy = dynamicParticle -> GetKineticEnergy();
 
+  if(kineticEnergy == eloss) { return; }
+
   G4double cutEnergy = DBL_MAX;
   size_t cutIndex = couple -> GetIndex();
@@ -777,5 +884,5 @@
   // If parameterization for ions is available the electronic energy loss
   // is overwritten
-  if(iter != lossTableList.begin()) {
+  if(iter != lossTableList.end()) {
 
      // The energy loss is calculated using the ComputeDEDXPerVolume function
@@ -832,5 +939,4 @@
 
      }
-
   }
 
@@ -854,5 +960,5 @@
   G4double transitionEnergy = dedxCacheTransitionEnergy;
 
-  if(iter != lossTableList.begin() && transitionEnergy < kineticEnergy) {
+  if(iter != lossTableList.end() && transitionEnergy < kineticEnergy) {
      chargeSquareRatio *= corrections -> EffectiveChargeCorrection(particle,
                                                                 material,
@@ -862,5 +968,5 @@
      eloss *= chargeSquareRatioCorr;
   }
-  else if (iter == lossTableList.begin()) {
+  else if (iter == lossTableList.end()) {
 
      chargeSquareRatio *= corrections -> EffectiveChargeCorrection(particle,
@@ -875,5 +981,5 @@
   // overwrite the energy loss (i.e. when the effective charge approach is
   // used)
-  if(iter == lossTableList.begin()) {
+  if(iter == lossTableList.end()) {
 
      G4double scaledKineticEnergy = kineticEnergy * dedxCacheGenIonMassRatio;
@@ -906,7 +1012,7 @@
      particleChangeLoss -> ProposeNonIonizingEnergyDeposit(nloss);
   } 
-
-}
-
+}
+
+// #########################################################################
 
 void G4IonParametrisedLossModel::BuildRangeVector(
@@ -1018,9 +1124,58 @@
 
   IonMatCouple ionMatCouple = std::make_pair(particle, material); 
- 
+
   E[ionMatCouple] = energyRangeVector;
   r[ionMatCouple] = rangeEnergyVector;
 }
 
+// #########################################################################
+
+G4double G4IonParametrisedLossModel::GetRange(
+                  const G4ParticleDefinition* particle, // Projectile
+		  const G4Material* material,           // Target Material
+	          G4double kineticEnergy) {
+
+  G4double range = 0.0;
+
+  IonMatCouple couple = std::make_pair(particle, material);
+
+  EnergyRangeTable::iterator iter = E.find(couple);
+
+  if(iter == E.end()) {
+     G4cerr << "G4IonParametrisedLossModel::GetRange() No range vector found."
+            << G4endl;
+
+     G4cout << "   Ion-material pair: " << particle ->GetParticleName()
+            << "  " << material -> GetName()
+            << G4endl
+            << "   Available couples:"
+            << G4endl;
+
+     EnergyRangeTable::iterator iter_beg = E.begin();
+     EnergyRangeTable::iterator iter_end = E.end();
+
+     for(;iter_beg != iter_end; iter_beg++) {
+         IonMatCouple key = (*iter_beg).first; 
+ 
+         G4cout << "           " << (key.first) -> GetParticleName()
+                << "  " << (key.second) -> GetName()
+                << G4endl;
+     }
+  }
+  else {
+     G4PhysicsVector* energyRange = (*iter).second;
+
+     if(energyRange != 0) {
+        G4bool b;
+
+        // Computing range for kinetic energy:
+        range = energyRange -> GetValue(kineticEnergy, b);
+     }
+  }
+
+  return range;
+}
+
+// #########################################################################
 
 G4double G4IonParametrisedLossModel::ComputeLossForStep(
@@ -1061,18 +1216,74 @@
         if(loss < 0.0) loss = 0.0;
      }
-
-#ifdef PRINT_DEBUG
-     G4cout << "G4IonParametrisedLossModel::ComputeLossForStep() E = " 
-            << kineticEnergy / MeV << " MeV * "
-            << value.energyScaling << " = "
-            << kineticEnergy * value.energyScaling / MeV 
-            << " MeV, dE/dx = " << dedx / MeV * cm << " MeV/cm = "
-            << dedx/factor/MeV*cm << " * " << factor << " MeV/cm; index = "
-            << value.dEdxIndex << ", material = " << material -> GetName()
-            << G4endl;
-#endif
-
   }
 
   return loss;
 }
+
+// #########################################################################
+
+G4bool G4IonParametrisedLossModel::AddDEDXTable(
+                                const G4String& name,
+                                G4VIonDEDXTable* table, 
+                                G4VIonDEDXScalingAlgorithm* algorithm) {
+
+  if(table == 0) {
+     G4cerr << "G4IonParametrisedLossModel::AddDEDXTable() Cannot "
+            << " add table: Invalid pointer."
+            << G4endl;      
+
+     return false;
+  }
+
+  // Checking uniqueness of name
+  LossTableList::iterator iter = lossTableList.begin();
+  LossTableList::iterator iter_end = lossTableList.end();
+  
+  for(;iter != iter_end; iter++) {
+     G4String tableName = (*iter) -> GetName();
+
+     if(tableName == name) { 
+        G4cerr << "G4IonParametrisedLossModel::AddDEDXTable() Cannot "
+               << " add table: Name already exists."      
+               << G4endl;
+
+        return false;
+     }
+  }
+
+  G4VIonDEDXScalingAlgorithm* scalingAlgorithm = algorithm;
+  if(scalingAlgorithm == 0) 
+     scalingAlgorithm = new G4VIonDEDXScalingAlgorithm; 
+ 
+  G4IonDEDXHandler* handler = 
+                      new G4IonDEDXHandler(table, scalingAlgorithm, name); 
+
+  lossTableList.push_front(handler);
+
+  return true;
+}
+
+// #########################################################################
+
+G4bool G4IonParametrisedLossModel::RemoveDEDXTable(
+				 const G4String& name) {
+
+  LossTableList::iterator iter = lossTableList.begin();
+  LossTableList::iterator iter_end = lossTableList.end();
+  
+  for(;iter != iter_end; iter++) {
+     G4String tableName = (*iter) -> GetName();
+
+     if(tableName == name) { 
+        delete (*iter);
+
+        lossTableList.erase(iter);
+        return true;
+     }
+  }
+
+  return false;
+}
+
+// #########################################################################
+
